package com.kz.maintenance.example.freemarker;

import java.io.*;
import java.util.*;

import org.eclipse.swt.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.browser.*;

import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateExceptionHandler;

public class MainFrame {
	
	public static void main(String[] args) {
		final Display display = new Display();
		Shell shell = new Shell(display);
		shell.setLayout(new FillLayout());
		Browser browser = null;
		
		try {
			browser = new Browser(shell, SWT.NONE);
		} catch (SWTError e) {
			e.printStackTrace();
		}
		
		if (browser != null) {
			/*  -     */
			Map<String, Object> root = new HashMap<String, Object>();
			root.put("firstValue", 0.47); /*  .    ( / ) */
			root.put("secondValue", 0.2); /*  */
			root.put("thirdValue", 0.33); /*  */
			root.put("fourthValue", 0.5); /*  */
			root.put("fifthValue", 0.8); /*  */
			root.put("name", " ");
			
			/*  freemarker */
			String path_flt = CurrentDir();
			File filepath = new File(path_flt);
			Configuration cfg = new Configuration(Configuration.VERSION_2_3_23);
			try {
				cfg.setDefaultEncoding("UTF-8");
				cfg.setTemplateExceptionHandler(TemplateExceptionHandler.HTML_DEBUG_HANDLER);
				cfg.setDirectoryForTemplateLoading(filepath);
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			/*    */
			Writer out = new StringWriter();
			try {
				Template temp = cfg.getTemplate("template.ftl");
				temp.process(root, out);
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			/*     browser */
			browser.setText(out.toString());
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}
	
	/**
     *       ,  
     *  .
     * @return -    .
     */
    private static String CurrentDir(){
    	String path = System.getProperty("java.class.path");
    	String FileSeparator = (String)System.getProperty("file.separator");
    	
    	int semicolon = path.indexOf(';');
    	if (semicolon == -1) {
        	return path.substring(0, path.lastIndexOf(FileSeparator)+1);
		} else {
			String interim = path.substring(0, semicolon);
	    	String temp = interim.substring(0, interim.lastIndexOf(FileSeparator)+1);
	    	return temp + "ftl";
		}
     }
}
